Subject: Re: bug: `git pull --rebase` breaks in the presence of pushurls

From: Phillip Wood <[email-masked]>
Date: Tue, 9 Dec 2025 16:03:21 +0000

On 09/12/2025 01:48, Kartik Agaram wrote:
> Should `git push` perhaps only update refs/remotes/origin/master if push to all pushurls succeeds (with the same result)? It seems like that would fix this issue. Does it not work in other scenarios?

While that would help in your example, I don't think that helps in 
general as there is no guarantee that any of the push urls refer to the 
same server as the pull url. If you set a single push url that pushes to 
mirror in your example then "git pull --rebase" still drops the local 
commit. I'm a bit confused by remote.pushDefault as if I set that to a 
url rather than a remote then it does not update any remote tracking 
refs. I had assumed it would behave the same as remote.<remote>.pushurl.

Thanks

Phillip